0.248 2022-09-28
----------------


MAME Testers bugs fixed
-----------------------
- 07173: [Original Reference] (midw8080/8080bw.cpp) ozmawars, ozmawars2: Ozma Wars sound is different to Space Invaders. (Robbbert)
- 07855: [Graphics] (atari/atarisy1.cpp) roadblst: Graphics become corrupted occasionally. (hap)
- 08407: [Media Support] (sony/psx.cpp) psa, pse, psj, psu: PlayStation Game Booster no longer functions. (Vas Crabb)


New working machines
--------------------
Conquest (prototype) [Code Mystics]
M8 Game Selectable Working Product Display (US, set 1) [kmg, Voodooween, Forest of Illusion, Fiskbit]
Micro Technology Unlimited MTU-130 [O. Galibert, David Williams, Disk Blitz, Eric Wright]


New working clones
------------------
Dance Dance Revolution 2nd Mix - Link Ver (GE885 VER. JAB) [Taro]
Fidelity Electronics Elegance Chess Challenger (model AS12, set 1) [Berger]
Golden Tee Golf (Trackball, v2.1) [Brian Troha, The Dumping Union]
M8 Game Selectable Working Product Display (US, set 2) [kmg, Voodooween, Forest of Illusion, Fiskbit]
M8 Game Selectable Working Product Display (US, set 3) [kmg, Voodooween, Forest of Illusion, Fiskbit]
Nintendo Famicom (earlier, with RP2A03) [kmg]
Soul Calibur (Asia, SOC12/VER.A2) [nnap]


Machines promoted to working
----------------------------
Hartung Game Master [hap]


Clones promoted to working
--------------------------
Sharp My Computer Terebi C1 [kmg]


New machines marked as NOT_WORKING
----------------------------------
Acchi Muite Hoi Battle [R. Belmont, Darksoft, TeamEurope]
Docchi Fighter [R. Belmont, Darksoft, TeamEurope]
Exciting Speed Hockey (V19930325) [nnap]
Facit 4431 [Dirk Best, Bitsavers]
International Business Machines RS/6000 Type 7009 Model C10 Server [R. Belmont, Captan Midnight]
Mogu Mogu Hammer [R. Belmont, Darksoft, TeamEurope]
Nikko Entertainment B.V. / Grey Innovation digiBLAST [TeamEurope]
Paradise (Industrias Brasilerias, Version 1.04) [Cristiano-MDQ]
Sala Due (Version 3.04) [Cristiano-MDQ]
Super Mario Bros. 3 (NES bootleg) [Victor Fernandez (City Game)]
Yamaha PSR-500 [Phil Bennett, BoxCubed]
Yamaha VL1 [O. Galibert, Hubert "madbrain" Lamontagne]
Zoomania (Version 10.04, set 1) [Cristiano-MDQ]


New clones marked as NOT_WORKING
--------------------------------
Dance Maniax (G*874 VER. AAA) [Verox Zik, Cereth]
DrumMania 9th Mix (G*D09 VER. JAB) [Taro]
DrumMania 9th Mix eAmusement (G*D09 VER. JCA) [Taro]
DrumMania 10th Mix eAmusement (G*D40 VER. JCA) [Taro]
Guitar Freaks 5th Mix (G*A26 VER. AAA) [Taro]
Guitar Freaks 11th Mix eAmusement (G*D39 VER. JBA) [Taro]
Maverick, The Movie (2.00) [Matt’s Basement Arcade, PinMAME]
Percussion Freaks 9th Mix (G*D09 VER. AAA) [Taro]
Percussion Freaks 10th Mix (G*D40 VER. AAA) [Taro]
Red and Ted's Road Show (PA-2 prototype) [Bill Ung, PinMAME]
Sala Due (Version 1.04) [Cristiano-MDQ]
Sharp Famicom Titler [kmg]
Strikers 1945 III (World) / Strikers 1999 (Japan) (bootleg) [Bigblue709]
Virtua Golf / Dynamic Golf (prototype) [brizzo, MetalliC, Mirko, rtw, XeD]
Zoomania (Version 10.04, set 2) [Cristiano-MDQ]


New working software list additions
-----------------------------------
a2600:
  Climber 5 (NTSC), Climber 5 (PAL), Gunfight (NTSC), Gunfight (PAL), Jammed, Marble Craze (NTSC), Marble Craze (PAL), Oystron,
  Qb (NTSC), Qb (PAL), Seawolf (NTSC), Seawolf (PAL), Space Instigators, Star Fire (NTSC), Star Fire (PAL), Synthcart, Testcart,
  Thrust+ - D.C. Edition, Thrust+ - Platinum Edition [AtariAge]
apple2gs_flop_orig: LemminGS, Space Ace II: Borf's Revenge [Antoine Vignau, A-Noid]
arb: Grand Master Series 3, Sargon 3.5 [Berger]
ekara_japan_s:
  Saiten Cartridge: Challenge Idol vol.4 (Japan) (SC0014-SAI), Saiten Cartridge: Challenge Idol vol.5 (Japan) (SC0020-SAI)
  [TeamEurope]
famicom_cass:
  Abunai Penpen!, Fruit Panic, Itazura Karasu, Kani-san no Hatahakobi, Star Dust, Star Ship Go!!, War Game
  [ozidual, Gaming Alexandria]
gbcolor:
  36 in 1 (SL36-0032), Chāojí Gédòu 2001 Alpha (Taiwan), Guàishòu Go! Go! Ⅱ (China), Gédòu Jiàn Shén - Soul Falchion (China),
  Kǒudài Guàishòu - Dòngzuò Piān (China), New Super Color 145 in 1 (China),
  Shǐshàng Chāoqiáng RPG + Gédòu + Yìzhì Bǎn Zǔhé Kǎ 18 in 1, Yín Bǎn Zhōngwén RPG Zhànlüè + Dòngzuò + Yìzhì 12 in 1
  [taizou, Vas Crabb]
ibm5150:
  California Pro Golf, Chess Simulator, Chicago 90, Command H.Q. (3.5"), Command H.Q. (5.25") [The Good Old Days]
  Expert Will (v1.4) [ibmpc5150, archive.org]
ibm5170_cdrom:
  Blackhawk (Europe), Supaplex (Europe) [Jackal, redump.org]
  Network Q RAC Rally (USA) [MrX_Cuci, redump.org]
megadriv: Super Spin (prototype) [GamingLegend64, Forest of Illusion]
nes:
  Indora no Hikari (Japan, prototype, 19870815), Wily & Light no RockBoard - That's Paradise (Japan, sample)
  [Zoda-Y13, Forest of Illusion]
spectrum_cass:
  Ficheiro Astor, Ilha dos Espiões (Timex), Spectrum Organ (Mark Lawrence) [Planeta Sinclair]
  Carlos Sainz (Musical 1), Cyberball (Erbe), Forbidden Planet (Design Design), Gehen Sie in das Gefängnis, Gemini Wing (Dro Soft),
  Golden Basket [spectrumcomputing.co.uk]


Software list items promoted to working
---------------------------------------
gameboy: Game Boy Camera (Europe, USA), Game Boy Camera Gold (USA), Pocket Camera (Japan, Rev 1) [Vas Crabb]
gbcolor:
  31 in 1 Mighty Mix (Taiwan), 31-in-1 Mighty Mix (Australia), 4 in 1 + 8 in 1 (World, 4B-001), 4 in 1 + 8 in 1 (World, 4B-002),
  4 in 1 + 8 in 1 (World, 4B-007), 4 in 1 + 8 in 1 + 16 in 1 (World, 4B-005), Command Master (Japan), Kirby Tilt 'n' Tumble (USA),
  Korokoro Kirby (Japan), Nǚwáng Gédòu 2000 (Taiwan), Street Hero (Taiwan), Thunder Blast Man (Europe) [Vas Crabb]
gmaster:
  Bubble Boy, Continental Galaxy, Go Bang, Kung Fu, Pin Ball, Soccer (3 on 3), Space Castle, Space Invader, Space Warrior, Tank War,
  Tennis [hap]
msx1_cart: Easi-Speech [hap]


New NOT_WORKING software list additions
---------------------------------------
c2color_cart: Dì 3 dàn: Zhī Yīngxióng Dǎo Zhī Lièyàn Mó [Peter Wilhelmsen]
cpc_flop:
  Roland In The Caves (UK), Roland In The Caves (UK) [Original], Roland In Time (UK), Roland In Time (UK) [Original],
  Roland in Time (Amsoft), Roland in Time (Amsoft FR) (Side A), Roland in Time (UK) [a1], Roland in Time (UK) [a2],
  Roland in the Caves (Euro), Roland in the Caves (Indescomp - Amsoft), Roland in the Caves (Indescomp - Amsoft)(es),
  Roland in the Caves (UK) [a1], Roland in the Caves (UK) [a2], Roland in the caves (Amsoft) (Slim Standard Jewel Case)
  [Barry Rodewald]
digiblast_cart:
  Sonic X 1 (Italy / Spain), Sponge Bob Square Pants 1 (Italy / Spain), Totally Spies! 1 (Italy),
  Winx Club + 5 Atari Games (Italy / Spain), Winx Club 1 (Italy / Spain), Yu-Gi-Oh! (Italy / Spain) [Most-Student-5165]


Translations added or modified
------------------------------
Chinese (Simplified) [YuiFAN]
Chinese (Traditional) [YuiFAN]
Greek [BraiNKilleRGR]
Ukrainian [Stanley Kid]


Merged pull requests
--------------------
- 10106: formats/fsmgr.cpp: Changed fs::manager_t::enumerate_f to simplify logic in file system implementations. [Nathan Woods]
- 10287: util/corestr.cpp: Changed core_stricmp to take std::string_view parameters. [Nathan Woods]
- 10290: nintendo/vsnes.cpp: Added some DIP switch settings for nvs_machridera. [kmg]
- 10291: cpu/z80: Fixed WZ flag. [holub]
- 10292: nintendo/vsnes.cpp: Corrected bnglngby Lives DIP switch settings, and added Difficulty settings. [kmg]
- 10293: pinball/de_3.cpp: Corrected description for jupk_501g. [ClawGrip]
- 10294: Marked sf2049se U27 as a good dump (POST checksum failure is normal). [neSneSgB]
- 10295: skeleton/digiblast.cpp: Added skeleton driver for Nikko Entertainment/Grey Innovation digiBLAST. [David Haywood]
- 10296: formats/fs_fat.cpp: Fixed use-after-std::move issue in constructor. [Nathan Woods]
- 10299: sound/nes_apu.cpp: Added earliest hardware variant of 2A03 APU (used in Vs. System and early Famicoms). [kmg]
- 10300: c2color_cart.xml: Added Dì 3 dàn: Zhī Yīngxióng Dǎo Zhī Lièyàn Mó (not working). [Peter Wilhelmsen, David Haywood]
- 10301: atari/atarigt.cpp:: Add Japanese release of Primal Rage version 2.3. [Lemon-King]
- 10304: technos/shadfrce.cpp: Added subtitle to Japanese set description. [Michael Sanborn]
- 10305: emu/video.cpp: Added a space before %FPS in speed text. [kmg]
- 10307: misc/highvideo.cpp: Added five Brazilian gambling games. [Cristiano-MDQ, David Haywood]
- 10309: Updated Greek Translation. [BraiNKilleRGR]
- 10311: nes.xml: Added a sample cartridge dump. [Zoda-Y13, Forest of Illusion, kmg]
- 10312: konami/ksys573.cpp: Added newly dumped versions of rhythm games. [Taro, Verox Zik, Cereth, Windy Fairy]
- 10315: act/victor9k.cpp, formats/victor9k_dsk.cpp: Fixed Victor 9000 disk handling. [Paul Devine]
- 10316: konami/ksys573: Add more DrumMania and Guitar Freaks versions. [Taro, Windy Fairy]
- 10318: bus/nes_ctrl: Added Sharp Cassette Interface AN-300SL device used by My Computer Terebi C1. [kmg]
- 10319: bfm/bfm_sc2.cpp Fixed µPD7759 sample triggering and made volume ramp less aggressive. [Paul-Arnold, David Haywood]
- 10321: bus/nes_ctrl: Fixed issues with Famicom Keyboard and Data Recorder affecting Lode Runner and Castle Excellent. [kmg]
- 10322: bfm/bfm_sc2.cpp: Fixed µPD7759 sample triggering and reset control correctly. [Paul-Arnold]
- 10323: ngp.xml, ngpc.xml: Cleaned up descriptions. [ArcadeShadow]
- 10324: megadriv.xml: Added an unreleased prototype. [GamingLegend64, Forest of Illusion, kmg]
- 10325: cdi.xml: Cleaned up descriptions. [ArcadeShadow]
- 10326: bus/nes_ctrl: Corrected Arkanoid 2 paddle expansion port signal routing. [kmg]
- 10327: nintendo/nes.xml: Added Sharp Famicom Titler (not working). [kmg]
- 10330: apple2gs_flop_orig.xml: Added LemminGS and Space Ace II: Borf's Revenge. [Antoine Vignau, A-Noid]
- 10331: nes.xml: Added another prototype cartridge. [Zoda-Y13, Forest of Illusion, kmg]
- 10338: nintendo/n64_v.cpp: Fixed buffer overrun in triangle drawing. [invertego]
- 10339: spectrum_cass.xml: Added nine working items and replaced three items with better dumps. [ArcadeShadow]
- 10341: Added drivers for Nintendo M8 and M82 product display systems. [kmg]
- 10342: nes.xml: Corrected indorap ROM label; nintendo/nes_m8.cpp: Made the parent system set 1. [kmg]
- 10343: Renamed N2A03 to RP2A03 throughout source tree. [kmg]
- 10346: coleco.xml: Cleaned up descriptions. [ArcadeShadow]
- 10347: c64_cart.xml: Cleaned up descriptions. [ArcadeShadow]
- 10348: fmtowns_flop_misc.xml: Cleaned up descriptions. [ArcadeShadow]
- 10349: ibm5170_cdrom.xml: Added three working items. [Jackal, MrX_Cuci, redump.org, ArcadeShadow]
- 10350: sega/megadriv_rad.cpp: Added option to use C button to access service menu in dgunl3227. [Devin Acker]
- 10354: Removed Japanese release of Primal Rage version 2.3 (reverts GitHub #10301). [Vas Crabb]
- 10355: docs: Updated build prerequisite package names for newer Ubuntu versions. [Golden Child]
- 10357: sv8000.xml: Added Japanese titles and release years, and changed ROM sizes to hexadecimal. [kmg]
- 10358: bandai/sv8000.cpp: Halved CPU clock frequency – fixes games running too fast. [kmg]
- 10359: famicom_cass.xml: Added six Micom BASIC Magazine games. [ozidual, Gaming Alexandria, kmg]
- 10360: arcadia.xml: Added Japanese titles to Bandai games. [kmg]
- 10361: ekara_japan_s.xml: Added two Challenge Idol cartridge dumps. [TeamEurope, David Haywood]
- 10363: famicom_cass.xml: Added one more Micom BASIC magazine game. [ozidual, Gaming Alexandria, kmg]
- 10364: a2600.xml: Added nineteen working homebrew cartridges. [AtariAge, kmg]
- 10365: ibm5150.xml: Added six working items. [The Good Old Days, ibmpc5150, archive.org, ArcadeShadow]


Source changes
--------------
-z1013: Correct XTAL value and screen parameters based on schematics; make system clock configurable [AJR]

-ladybug: move zerohour stars to its own file (redclash driver now doesn't weirdly include ladybug_v anymore) [hap]

-redclash: let's rename driver to zerohour [hap]

-OSD/network interface cleanup [AJR]
 * Move osd_midi_device from osdcore.h to osdepend.h
 * Move osd_list_network_adapters from osdcore.h to osdnet.h (was already defineduniquely in osdnet.cpp)
 * Move #include <cstdarg> from osdcore.h to emu.h
 * Remove dinetwork.h from emu.h

-Debugger changes [AJR]
 * Added exception points as a new class of "points" triggering on specific exception numbers, with a similar set of commands to
    breakpoints and registerpoints.
 * Removed the per-instruction callback hook from device_debug. Only one driver was using this (rmnimbus.cpp), and what it was doing
    with it could be done more cleanly with exception points.
 * Change the type of the action string parameter for "points"-creating methods and make some parameters optional for those.
 * Change trace file logging to use a std::ostream instead of FILE * to take better advantage of strformat.

-Fix tools build after f52b402f2416ddfd646afe2d132c16d78c6fe9c3 [AJR]

-nintendo/vsnes.cpp: Added some DIP settings for nvs_machridera. (#10290) [0kmg]

-ladybug: put sraider driver and ladybug_video device in their own files [hap]

-zerohour: put driver into a single file [hap]

-zerohour: add sound samples again [hap]

-redclash: add white background [hap]

-redclash: add preliminary sound [hap]

-zerohour: correct score panel colors [hap]

-z80.cpp: fix WZ flag (#10291) [holub]

-de_3.cpp: Forgot to remove country name on commit cf89d216b02524ab568a71d92c4db3bc4b5234f3 (#10293) [ClawGrip]

New machines marked as NOT_WORKING
----------------------------------
Facit 4431 [Bitsavers]

-Create directory for Facit and move facit4440 driver [Dirk Best]

-zerohour: remove imperfect gfx flag for this game [hap]

New machines marked as NOT_WORKING
----------------------------------
Exciting Speed Hockey (V19930325) [nnap]

New clones marked as NOT_WORKING
--------------------------------
Red and Ted's Road Show (PA-2 prototype) [Bill Ung, PinMAME]

-sega/model3.cpp, sega/segaybd.cpp: some board documentation updates [Brian Troha]

-tecmo/spbactn.cpp: fixed some dips for spbactnp [Ivan Vangelista]

-zerohour: bullet width is software controlled [hap]

-zerohour: update notes [hap]

-taito/groundfx.cpp, taito/pitnrun.cpp, taito/rollrace.cpp, taito/ssrj.cpp, taito/volfied.cpp, taito/warriorb.cpp: consolidated
 drivers in single files, minor cleanups [Ivan Vangelista]

-formats/fs_fat.cpp: Fixe use-after-std::move() issue in constructor. (#10296) [npwoods]

-getaway: improve colors, add dipsw locations [hap]

-atarisy1, gauntlet: re-add boost interleave on soundlatch write [hap]

-gen_latch: add boost interleave conf setting [hap]

-Revert "gen_latch: add boost interleave conf setting" [Vas Crabb]
 * Jamming magic behaviour for a few systems into a common device just makes code more convoluted and harder to maintain.  The
    trouble with these things is that you quickly end up stuck with them, and then untangling the dependency on magical behaviour
    that never belonged in the device in the first place becomes an inordinate amount of work.
 * In this case, it isn't even saving a substantial amount of code in the drivers.
 * This reverts commit 229ea4b3a1b44bd558e2c99c31dfe3ad66c34ea0.

-zerohour_stars: remove need for trampoline [hap]

-taito/galastrm.cpp, taito/gunbustr.cpp, taito/msisaac.cpp: consolidated drivers in single files, minor cleanups [Ivan Vangelista]

-taito/msisaac.cpp: removed unused variable [Ivan Vangelista]

-woz: Remove write support, it can't really be made reliable moof: Added support. [Olivier Galibert]

-esqkt.cpp: Added TS-10 2.02 and TS-12 3.05 OS ROMs. [DBWBP.com, R. Belmont]

-moof: Some fixes [Disk Blitz] woz: put back the save support, will destroy any disk with FLUX encoded tracks though.  How to handle
 that is still in discussion. [Olivier Galibert]

-Validate slot cards only once per device type during 'quick' validation passes, which were taking rather long for some drivers
 (e.g. at.cpp) [AJR]

-docastle: update notes [hap]

-woz: fix missing breaks [Olivier Galibert]

-Add file inadvertently omitted from 67be13960b2fffa5460c3e5dbb0a7f9736b87d3e [AJR]

-Patched up some gaps in functionality and fixed some bugs. [Vas Crabb]
 * ui: Added some missing functionality:
   - Added an option to copy input device IDs to the relevant menus.
   - Added an item for setting the software lists files path (-hashpath) to the folder setup menu.
   - Allow pasting text from clipboard in most places that allow typing (searching, entering filenames, entering barcodes).
   - Changed the software selection menu heading to be a bit less misleading.
   - Made barcode menu less eager to rebuild itself unnecessarily, and removed some confusing and apparently pointless code.
     * Exposed more Lua bindings:
   - Added low-level palette objects.
   - Added indexed bitmap types.
   - Added a bitmap method for extracting pixels from a rectangular area as a packed binary string.
   - Changed screen device pixels method to return width and height in addition to the pixels.
     * osd: Added some functionality and cleaned up a little:
   - Added a function for copying text to the clipboard.
   - Moved function for converting Windows error codes to standard error conditions to winutil.cpp so it can be used from more
      places.
   - Removed duplicate declaration of osd_get_clipboard_text and made the function noexcept (including fixing implementations).
   - Made macOS implementation of osd_get_clipboard_text skip the encoding conversion if it finds UTF-8 text first.
   - Changed the default -uimodekey setting so it doesn't lose the "not shift" that stops the default from interfering with UI
      paste.
     * Various bug fixes:
   - util/unicode.cpp: Fixed the version of utf8_from_uchar that returns std::string blowing up on invalid codepoints.
   - util/bitmap.h: Fixed wrapping constructors for indexed bitmaps taking the wrong parameter type (nothing was using them before).
   - util/bitmap.cpp: Fixed potential use-after-free issues with bitmap palettes.
   - emu/input.cpp, emu/inputdev.cpp: Log 1-based device numbers, matching what's shown in the internal UI and used in tokens in CFG
      files.
   - emu/emumem.cpp: Added the bank tag to a fatal error message where it was missing.
     * docs: Reworked and expanded documentation on configuring stable controller IDs.
     * For translators, the changes are quite minor:
   - There's a menu item for copying a device ID to the clipboard, and associated success/failure messages.
   - There's the menu item for setting the software list file search path.
   - One of the lines in the software selection menu heading has changes as it could be interpreted as implying it showed a software
      list name.

New machines marked as NOT_WORKING
----------------------------------
Super Mario Bros. 3 (NES bootleg) [Victor Fernandez (City Game)]

-misc/mcatadv.cpp, misc/oneshot.cpp, taito/retofinv.cpp: consolidated drivers in single files, minor cleanups [Ivan Vangelista]

-cpu/psx: Initialise some DMA channel registers on reset (fixes MT08407). [Vas Crabb]
 * Without this, booting a parallel port device jumps into the weeds. Actual DMA channel state on reset needs to be investigated.

-f4431:  Emulate keyboard, add layout for keyboard LEDs, honor cliprect for screen update [Dirk Best]

-nintendo/vsnes.cpp: Improved DIP switch labels for jajamaru, bnglngby and supxevs. (#10292) [0kmg]
 * Corrected bnglngby Lives DIP switch settings, added Difficulty settings.
 * Corrected supxevs Bonus Life DIP switch settings, added Password DIP settings.
 * Corrected Lives DIP switch settings for jajamaru.

-zerohour: add 1bit dac [hap]

-driver: make flipscreen setters compatible with writeline [hap]

-schedule: rename add_scheduling_quantum to add_quantum, added perfect_quatum and use that for most cases of boost_interleave [hap]

-Fix regressions in debugger trace command from d8d588262de1f11a529b208e470cff9b89a4cba6, including use-after-move issue [AJR]

-gaelco/blmbycar.cpp, gaelco/glass.cpp, gaelco/targeth.cpp, gaelco/wrally.cpp, gaelco/xorworld.cpp, gametron/gatron.cpp,
 gametron/sbugger.cpp: consolidated drivers in single files, minor cleanups [Ivan Vangelista]

-redclash: add player shoot sample [hap]

-ozmawars: Added preliminary samples to replace the incorrect invaders ones. [Robbbert]

-sound/nes_apu.cpp: Added earliest hardware variant of 2A03 APU. (#10299) [0kmg]
 * Fixes several audio bugs with the noise channel in VS. System games, including:
   - High-pitch sound in vsgshoe percussion track.
   - Jet sounds in bnglngby.
   - Number of tanks killed count screen in btlecity.
   - nvs_platoon's bullet and enemies dying sounds are subtly changed.
     * It's estimated that these letterless CPU versions are in the first two million or so Famicoms (about 10% of Famicoms sold).
        There are games developed on the RP2A03 that have sound glitches on later, more common Famicoms.  For instance, the very
        last note in the game over melody in Balloon Fight rings out with a loud buzz on later machines.  The new famicomo driver
        plays it as the developers must have intended.

New working clones
------------------
Nintendo Famicom (earlier, with RP2A03) [kmg]

new NOT WORKING software list entries (#10300)
----------------------------------------------
c2color_cart.xml: Dì 3 dàn: Zhī Yīngxióng Dǎo Zhī Lièyàn Mó [Peter Wilhelmsen]

-c2color_cart.xml: Corrected metadata based on packaging. [David Haywood]

-Language updates, software demotions, and minor code cleanup. [Vas Crabb]
 * Updated Chinese UI translations. [YuiFAN]
 * Updated Ukrainian UI translation. [Stanley Kid]
 * gbcolor.xml: Demoted beastfgt to partially supported (HUD blank on GBC), and demoted emochndx to unsupported due to all kinds of
    broken behaviour.  Also added chongwu title from title screen as another alt_title - it's different to the cartridge label.

-speedbsk.cpp: Add sound banking [AJR]

-rockrage.cpp: document why rockragea is marked as "prototype?" [Angelo Salese]

-z80ne: merge driver into a single file [hap]

-redclash: add minimal beeper frequency [hap]

-cmi: move global int_levels array to local function where it's accessed [hap]

-toprollr: add safety cliprect mask [hap]

-glasgow/amsterdam: rom regions were 256 times too large somehow [hap]

-source org: move z80ne to misc folder [hap]

-amstrad: reorganised softlist entries for Roland in Time, Roland in Space, and Roland in the Caves [Barry Rodewald]

-Updated Greek Translation (#10309) [BraiNKilleRGR]

-emu/video.cpp: Added a space before %FPS in speed text. (#10305) [0kmg]

new NOT_WORKING machine
-----------------------
Virtua Golf / Dynamic Golf (prototype) [brizzo, MetalliC, Mirko, rtw, XeD]

-machine/intelfsh.cpp: Added Macronix 29F008TC (1M*8, 4K*8 pages). [Vas Crabb]

-bgfx: Removed obsolete sample layout files, updated documentation. [Vas Crabb]

New NOT_WORKING software list items (gbcolor.xml)
-------------------------------------------------
Chāojí Gédòu 2001 Alpha (Taiwan) [taizou]
Gédòu Jiàn Shén - Soul Falchion (Taiwan) [taizou]

-ymqy70.cpp: Fix permissions [AJR]

-jaleco/aeroboto.cpp, jaleco/exerion.cpp, jaleco/ginganin.cpp, jaleco/homerun.cpp, jaleco/momoko.cpp, jaleco/skyfox.cpp,
 omori/popper.cpp: consolidated drivers in single files, minor cleanups [Ivan Vangelista]

New working clones
------------------
Golden Tee Golf (Trackball, v2.1) [Brian Troha, The Dumping Union]

-ozmawars: fixed typo. [Robbbert]

-midw8080/8080bw_a.cpp: confirmed ozmawars has 2 SN76477 [Guru]

-orca/espial.cpp, orca/funkybee.cpp, orca/marineb.cpp, orca/vastar.cpp, orca/zodiack.cpp, pacific/mrflea.cpp, pacific/thief.cpp:
 consolidated drivers in single files, minor cleanups [Ivan Vangelista]

-seattle.cpp: added newer BIOS for blitz [anonymous]

-6502 future-proofing: do not overwrite the variable with the access address on a read in case we want to rerun it
 [Olivier Galibert]

new WORKING machine
-------------------
MTU-130 [Olivier Galibert, David Williams, Disk Blitz, Eric Wright]

New clones added as WORKING (#10312)
------------------------------------
Dance Dance Revolution 2nd Mix - Link Ver (GE885 VER. JAC) [Taro]

New clones added as NOT_WORKING
-------------------------------
Guitar Freaks 5th Mix (G*A26 VER. AAA) [Taro]
Percussion Freaks 9th Mix (G*D09 VER. AAA) [Taro]
Percussion Freaks 10th Mix (G*D40 VER. AAA) [Taro]
Dance Maniax (G*874 VER. AAA) [Verox Zik, Cereth]
Drummania 9th Mix Multisession Disc [SakamotoNeko]

-highvideo.cpp: new NOT WORKING machines (Brazilian gambling games) (#10307) [David Haywood]
 * Also got rid of function statics, made some of the other sets in here that didn't boot, boot, and set some to the correct machine
    type so the video renders as it should.

new NOT WORKING machines
------------------------
Zoomania (Version 10.04, set 1) [Cristiano-MDQ]
Sala Due (Version 3.04) [Cristiano-MDQ]
Paradise (Industrias Brasilerias, Version 1.04) [Cristiano-MDQ]

new NOT WORKING clones
----------------------
Sala Due (Version 1.04) [David Haywood]
Zoomania (Version 10.04, set 2) [Cristiano-MDQ]

-nes.xml: Added a sample cartridge dump. (#10311) [0kmg]

New working software list additions
-----------------------------------
nes.xml: Wily & Light no RockBoard - That's Paradise (Japan, sample) [Zoda-Y13, Forest of Illusion]

-midway/seattle.cpp: Added San Francisco Rush Boot Code Version L1.12 as a BIOS option. [neSneSgB]

-gameboy.xml, gbcolor.xml: Mark HuC-1 cartridges as using non-volatile RAM, and demoted to partially supported for lack of IR
 transceiver emulation. [Vas Crabb]

-Various cleanups: [Vas Crabb]
 * midway/seattle.cpp: Turned San Francisco Rush Boot Code Version L1.06A into a BIOS option rather than a clone - the game version
    is the same.
 * misc/highvideo.cpp: Use a more obvious pixel loop with fewer tests, and cleaned up spacing.
 * tvgames/micom_mahjong.cpp: Use active low logic for active low key matrix rather than inverting stuff everywhere.
 * pacific/thief.cpp: Cleaned up indentation gone wild.

-M740 fixes (mostly related to 6563dfe9cf93c4e39b3ea9caa73c050147644075) [AJR]

-Victor9k fix disk handling (#10315) [Paul Devine]
 * Victor9k Fixing bug in floppy disk sync header sizes
 * Victor9K adding support for ramsize CLI flag
 * Fixed zone 4 documentation bug
 * Correcting mistake in data header sync size, 5 not 6 bytes
 * fixed error in sector size comparison & sector count for DS disks
 * single-sided disks read/write correctly; double-sided read correctly. DS still corrupting on write
 * fixed bug in offset calculation for DS disks
 * fixing bug with -ramsize=896K
 * updated todo comment
   - Co-authored-by: Paul Devine <pauldevine+git@gmail.com>

-Add preliminary M50734 emulation [AJR]

-m50734: device_reset fix [AJR]

-m740: Only access data memory in indirect modes [AJR]

-m50734: Fix stack page [AJR]

-Add skeleton devices for MPS-1200 & MPS-1250 IEC printers [AJR]

-m740: Remove leftover declarations from header [AJR]

-vic1520: Correct MCU type; add some stub handlers [AJR]

-kaneko/airbustr.cpp, kaneko/djboy.cpp, nix/pirates.cpp, sanritsu/bankp.cpp, sanritsu/drmicro.cpp, sanritsu/mjkjidai.cpp:
 consolidated drivers in single files, minor cleanups [Ivan Vangelista]

-f4431: Improve video emulation, hook up RS232 comm port [Dirk Best]

-airbustr: add kaneko_hit device [hap]

-fix upd7759 sample triggering in bfm_sc.2.cpp (MT 8325) [Paul-Arnold] (#10319) [David Haywood]
 * (also made the volume ramp a little less aggressive, I'm told 0 is not 'nearly silent' on the hardware, but more like 'half
    volume')

-m50734: Add A-D converter [AJR]

New machines added as MACHINE_NOT_WORKING
-----------------------------------------
IBM RS/6000 Type 7009 Model C10 Server [R. Belmont, Captain Midnight]

-nichibutsu/gomoku.cpp, nichibutsu/wiping.cpp: consolidated drivers in single files, minor cleanups [Ivan Vangelista]

-olibochu: improve ay sound [hap]

-Update mess.flt [Robbbert]

-fix upd7759 sample triggering and reset control (#10322) [Paul-Arnold]

-bus/nes_ctrl: Added Sharp Cassette Interface AN-300SL device. (#10318) [0kmg]

Clones promoted to working
--------------------------
Sharp My Computer Terebi C1 [kmg]

-bus/nes_ctrl: Minor fixes for Famicom Keyboard and Data Recorder. (#10321) [0kmg]
 * bus/nes_ctrl: Minor fixes for Famicom Keyboard and Data Recorder.
   - Allows Lode Runner to successfully detect keyboard, enabling save/load menu options.
 * Also fix Arkanoid 2 saving to tape.

-olibochu: added adpcm sound [hap]

-mtu130: Add support for the datamover (68k board) [Olivier Galibert]

-olibochu: add hc55516 device instead of adpcm [hap]

-olibochu: added confsetting for the palette [hap]

-gameboy.xml, gbcolor.xml: Demoted HuC-3 games to partially working. [Vas Crabb]

-imagedev/picture.cpp: Added extensions for supported BMP and JPEG formats. [Vas Crabb]

New machines added as MACHINE_NOT_WORKING
-----------------------------------------
Mogu Mogu Hammer [R. Belmont, Darksoft, Team Europe]

-qix: slither was published by GDI [hap]

-mmarvin: just use PORT_ADJUSTER for the tone/speed configuration knobs [hap]

New machines added as MACHINE_NOT_WORKING
-----------------------------------------
Yamaha VL-1 [O. Galibert, Hubert "madbrain" Lamontagne]

-microvision: add horizontal bar for paddle pos [hap]

-b6100: don't write to speaker on tkbs [hap]

-Reimplemented Game Boy and Mega Duck cartridge slots: [Vas Crabb]
 * Allow cartridges to install themselves rather than putting accesses through trampolines.  Use memory banks even when they aren't
    installed directly, as it exposes script bindings and declares intent.
 * Added support for MBC6 Flash, and MBC7 two-axis accelerometer and 128*16 or 256*16 serial EEPROM.  Added basic support for Game
    Boy Camera image capture (various M64282FP processing features are not implemented). Improved MBC3 real-time clock emulation.
 * Added basic support for Hudson Soft HuC-1 cartridges (infrared I/O not supported) and HuC-3 cartridges (real-time clock and
    infrared I/O not supported).
 * Added full support for Vast Fame VF001 cartridges.
 * Separated Mega Duck flat and banked ROM cartridge types, and allowed software list items to specify whether a cartridge has fixed
    and selectable 16K banks or a single selectable 32K bank.
 * Added support for RAM sizes smaller than 8K that will be mirrored in the 0xA000-0xBFFF area.  Implemented correct ROM mapping for
    sizes that are not powers of two.  Corrected size of MBC2 internal static RAM.
 * Added support for various hypothetical cartridge wirings, such as MBC5 with outer ROM banking for up to 128M, M161 and Wisdom
    Tree cartridges with flat RAM, and MBC1 or MBC5 with fewer than the maximum number of inner ROM bank lines used.
 * Fixed logo spoofing logic for many pirate cartridges, including Rocket Games, Sachen MMC1 and MMC2, Sintax, Li Cheng, and
    Niutoude.  Identified fine bank mask register for GBCK003 board.
 * Added basic support for GBX format ROM images.  Added heuristic for detecting raw dumps of M161 cartridge images.  Removed
    unreliable unlicensed cartridge detection heuristics - these need to be reimplemented in a better way.

Software list items promoted to working
---------------------------------------
gameboy.xml: [Vas Crabb]
Game Boy Camera (Europe, USA) [Vas Crabb]
Game Boy Camera Gold (USA) [Vas Crabb]
Pocket Camera (Japan, Rev 1) [Vas Crabb]
gbcolor.xml: [Vas Crabb]
Command Master (Japan) [Vas Crabb]
Kirby Tilt 'n' Tumble (USA) [Vas Crabb]
Korokoro Kirby (Japan) [Vas Crabb]
Street Hero (Taiwan) [Vas Crabb]
Thunder Blast Man (Europe) [Vas Crabb]
4 in 1 + 8 in 1 (World, 4B-001) [Vas Crabb]
4 in 1 + 8 in 1 (World, 4B-002) [Vas Crabb]
4 in 1 + 8 in 1 + 16 in 1 (World, 4B-005) [Vas Crabb]
4 in 1 + 8 in 1 (World, 4B-007) [Vas Crabb]
31 in 1 Mighty Mix (Taiwan) [Vas Crabb]
31-in-1 Mighty Mix (Australia) [Vas Crabb]
Nǚwáng Gédòu 2000 (Taiwan) [Vas Crabb]
Chāojí Gédòu 2001 Alpha (Taiwan) [Vas Crabb]
Gédòu Jiàn Shén - Soul Falchion (Taiwan) [Vas Crabb]

-misc/amuzy.cpp: make it populate a display list, other misc notes [angelosa]

-bus/gameboy: Some header comment corrections. [Vas Crabb]

-Updated arcade.flt and mess.flt [Robbbert]

-bus/gameboy/mbc.cpp: Fixed up some details. [Vas Crabb]
 * MBC5 checks all the bits of the RAM enable register.  Not sure if any games actually depend on this.
 * Changed MBC3 device to support an additional RAM bank output so it can run the one MBC30 game (Pocket Monsters Crystal).

-embargo: remove input tag lookups [hap]

-bus/gameboy: Added basic HuC-3 real-time clock simulation, and cleanup. [Vas Crabb]
 * Added MBC30 as a distinct slot option for documentation purposes.
 * Added heuristics to detect MBC30 for GBX and plain ROM dump files.
 * mbc.cpp: Disabled noisy logging.

-nes.xml: Added another prototype cartridge. (#10331) [0kmg]

New working software list additions
-----------------------------------
nes.xml: Indora no Hikari [Zoda-Y13, Forest of Illusion]

New NOT_WORKING clones (#10327)
-------------------------------
Famicom Titler [kmg]

-bus/nes_ctrl: Corrected Arkanoid 2 paddle expansion port signal routing. [0kmg]

-cdi.xml: Metadata cleaning (#10325) [ArcadeShadow]
 * Removed the "[DVC enhanced]" in descriptions, since the info compatibility tag already tells that.
 * Replaced an abbreviated country name.

-megadriv.xml: Added an unreleased prototype. (#10324) [0kmg]

New working software list additions
-----------------------------------
megadriv.xml: Super Spin (prototype) [GamingLegend64, Forest of Illusion]

-konami/ksys573.cpp: Added more Gutar Freaks/DrumMania clones. (#10316) [987123879113]
 * Also fixed parenting for pcnfrk9ma and pcnfrk10ma.

New clones marked NOT_WORKING
-----------------------------
DrumMania 9th Mix (G*D09 VER. JAB) [Taro]
DrumMania 9th Mix eAmusement (G*D09 VER. JCA) [Taro]
DrumMania 10th Mix eAmusement (G*D40 VER. JCA) [Taro]
Guitar Freaks 11th Mix eAmusement (G*D39 VER. JBA) [Taro]

-ngp.xml; ngpc.xml: Metadata cleaning: (#10323) [ArcadeShadow]
 * Replaced the country name abbreviations with full names.
 * Use lowercase for descriptive text in descriptions.

-technos/shadfrce.cpp: Added subtitle to Japanese set description. (#10304) [Michael Sanborn]

-midway/vegas.cpp: Removed bad dump flag from sf2049se U27. (#10294) [neSneSgB]
 * The POST checksum failure for the boot ROM was normal for this game.

-Added skeleton driver for Nikko Entertainment/Grey Innovation digiBLAST (#10295) [David Haywood]
 * bus/centronics/digiblst.cpp: Changed device short name to make it more explicit.

new NOT WORKING machine
-----------------------
Nikko Entertainment B.V. / Grey Innovation digiBLAST [TeamEurope]

new NOT WORKING software list items
-----------------------------------
digiblast_cart.xml: [David Haywood]
Sonic X 1 (Italy / Spain) [Most-Student-5165]
Sponge Bob Square Pants 1 (Italy / Spain) [Most-Student-5165]
Totally Spies! 1 (Italy) [Most-Student-5165]
Yu-Gi-Oh! (Italy / Spain) [Most-Student-5165]
Winx Club 1 (Italy / Spain) [Most-Student-5165]
Winx Club + 5 Atari Games (Italy / Spain) [Most-Student-5165]

Software list items promoted to working
---------------------------------------
msx1_cart: Easi-Speech [hap]

-bus/nes_ctrl: Cleaned up Famicom keyboard inputs; bus/gameboy: Shut up a couple of coverity warnings. [Vas Crabb]

-More miscellaneous fixes: [Vas Crabb]
 * Fixed tiny build for consolidated driver files.
 * tools/unidasm.cpp: Capture big objects by reference in lambdas.
 * misc/oneshot.cpp: Fixed unsigned comparison to zero bugs.

-New working software list additions (apple2gs_flop_orig.xml) (#10330) [A-Noid33]

New working software list additions (apple2gs_flop_orig.xml)
------------------------------------------------------------
Space Ace (Brutal Deluxe) [Antoine Vignau, A-Noid]
Space Ace II: Borf's Revenge [Antoine Vignau, A-Noid]
LemminGS [Antoine Vignau, A-Noid]

-Updated mess.flt [Robbbert]

-msx holy_quran: small cleanup [hap]

New working clones
------------------
Elegance Chess Challenger (model AS12, set 1) [Berger]

-util/corestr.cpp: Changed core_stricmp to take std::string_view parameters. (#10287) [npwoods]
 * Note that the implementation is still not UTF-8 aware.

-atari/atarigt.cpp:: Add Japanese release of Primal Rage version 2.3. (#10301) [Lemon-King]

New clones marked not working
-----------------------------
Primal Rage (Japan, version 2.3) [Lemon-King]

-Fixes and cleanup: [Vas Crabb]
 * gbcolor.xml, bus/gameboy: Renamed slot option for Rocket Games cartridges from "rom_atvrac" to "rom_rocket".
 * emu/config.cpp: Made error messages more detailed when opening a configuration file fails, and bumped error messages to warning
    level.
 * tools/imgtool: Fixed build.

-bus/gameboy/mbc.cpp: Added support for HK0701 and HK0819 bootlegs. [Vas Crabb]

New working software list additions
-----------------------------------
gbcolor.xml: Guàishòu Go! Go! Ⅱ (China) [taizou, Vas Crabb]
gbcolor.xml: Kǒudài Guàishòu - Dòngzuò Piān (China) [taizou, Vas Crabb]

-gbcolor.xml: Put the PCB designations on the right items. [Vas Crabb]

-Reallow debugger single-step command to break into subroutines during over/out stepping [AJR]

New working machines
--------------------
Conquest (prototype) [Code Mystics]

-blasterkit: fix regression [hap]

New machines marked as NOT_WORKING
----------------------------------
Yamaha PSR-500 [Phil Bennett]

-er1400: Fix loss of the first data bit on readback [Dirk Best]

-f4431: Working EAROM support, provide default NVRAM [Dirk Best]

-diagnostics: fix symbol backtrace with current objdump [Patrick Mackinlay]

-conquest: don't assume it has 8bit nvram [hap]

-fixes for clang 15.0 on windows [smf]

-fix visual studio builds after bdb9404c08908249210be53ddd640c165e6df1ed [smf-]

-plaparse: remove not strictly needed use of strrchr [hap]

-source org: move gmaster to handheld folder [hap]

-gmaster: improve sound [hap]

-gmaster: removed unused ports [hap]

-gmaster: add lcd chips [hap]

New machines added as MACHINE_NOT_WORKING
-----------------------------------------
Docchi Fighter [R. Belmont, Darksoft, Team Europe]

-diagnostics: preserve compatibility with old objdump [Patrick Mackinlay]

-debugger/win: Added capability to save/restore window arrangement. [Vas Crabb]
 * Format is mostly compatible with the Cocoa debugger, besides reversed vertical positioning.
 * Made Qt debugger more compatible with configuration format used by Win32 and Cocoa debuggers.
 * emu/config.cpp: Preserve elements with no registered handlers in default and system configuation files.

-fidelity as12: add nvram [hap]

-sed1520: don't write to ram when column address out of range [hap]

-upd7810: don't change carry flag with inr/dcr opcodes [hap]

-Added a crude dark theme for the Win32 debugger. [Vas Crabb]
 * Also made a start on weaning the Qt debugger off its weird configuation objects.  It can now save more view state with less
    string comparisons on memory labels, but it can't restore all of it yet.

Machines promoted to working
----------------------------
Game Master [hap]

New machines added as MACHINE_NOT_WORKING
-----------------------------------------
Achi Muite Hoi Batoru [R. Belmont, Darksoft, Team Europe]

-Emulate MN18801A MMU [AJR]

-upd7810: update prev commit: still affect HC flag [hap]

-gmaster: tweak lcd color [hap]

-Revert "er1400: Fix loss of the first data bit on readback" [Dirk Best]
 * This reverts commit 0fde33c2dd15e0d97dc40e5bfc21dca4937d18c8.

-redclash: fix stuck sound on highscore screen [hap]

-n64: fix stack buffer overflow (#10338) [invertego]

-wy50.cpp: Note [AJR]

-misc/amuzy.cpp: Corrected title of Acchi Muite Hoi Battle [Vas Crabb]

-misc/amuzy.cpp: Change the short name in the other place [Vas Crabb]

-Moved Nintendo M8 and M82 product display units out of NES driver. (#10341) [0kmg]
 * nintendo/nes_m82.cpp: Moved m82 to separate source file and added partial implementation. Added missing graphics ROM. Got rid of
    m82p for now.
 * nintendo/nes.cpp: Corrected name of "Twin Famicom". Switched famitvc1 to use older RP2A03.

New working machines
--------------------
Nintendo M8 Game Selectable Working Product Display (US, set 3) [kmg, Voodooween, Forest of Illusion, Fiskbit]

New working clones
------------------
Nintendo M8 Game Selectable Working Product Display (US, set 1) [kmg]
Nintendo M8 Game Selectable Working Product Display (US, set 2) [kmg]

-gmaster: update notes [hap]

-bus/gameboy: Added partial support for some Chinese multi-game cartridges. [Vas Crabb]
 * Cartridge RAM features are not implemented yet.

New working software list items
-------------------------------
gbcolor.xml: New Super Color 145 in 1 (China) [taizou, Vas Crabb]

-gbcolor.xml: Actually fill in CRC for added cartridge [Vas Crabb]

-upd7810: refresh port C on MCC related output changes [hap]

-bus/gameboy: Added support for two Vast Fame multi-game cartridges. [Vas Crabb]
 * Neither of these use per-game cartridge RAM banking, but they do segregate the RAM between games and disable it for games that
    don't need it.

New working software list additions
-----------------------------------
gbcolor.xml: Yín Bǎn Zhōngwén RPG Zhànlüè + Dòngzuò + Yìzhì 12 in 1 [taizou, Vas Crabb]
gbcolor.xml: Shǐshàng Chāoqiáng RPG + Gédòu + Yìzhì Bǎn Zǔhé Kǎ 18 in 1 [taizou, Vas Crabb]

-bus/gameboy: Added support for banked RAM games in multi-game carts. [Vas Crabb]

New working software list items
-------------------------------
gbcolor.xml: 36 in 1 (SL36-0032) [taizou, Vas Crabb]

-spectrum_cass: New working software list additions (#10339) [ArcadeShadow]
 * spectrum_cass: New working software list additions

New working software list additions
-----------------------------------
Carlos Sainz (Musical 1) [spectrumcomputing.co.uk]
Cyberball (Erbe) [spectrumcomputing.co.uk]
Ficheiro Astor [Planeta Sinclair]
Forbidden Planet (Design Design) [spectrumcomputing.co.uk]
Gehen Sie in das Gefängnis [spectrumcomputing.co.uk]
Gemini Wing (Dro Soft) [spectrumcomputing.co.uk]
Golden Basket [spectrumcomputing.co.uk]
Ilha dos Espiões (Timex) [Planeta Sinclair]
Spectrum Organ (Mark Lawrence) [Planeta Sinclair]

Redump software
---------------
Comecocos (Investronica) [spectrumcomputing.co.uk]
Go To Jail (release 1) [spectrumcomputing.co.uk]
Nightmare Rally (set 3, Erbe) [spectrumcomputing.co.uk]

-upd7810: upd78c06 has internal rom [hap]

-gamepock: merge driver files [hap]

-debugview.mm: full dark mode support for macOS 10.14 and later [R. Belmont]

-bus/gameboy: Fixes for multi-game cartridges. [Vas Crabb]
 * Reset the system from a timer callback for the Vast Fame/SL/J.Y. Company multi-game cartridges.  This fixes games on gbcolor.
 * Reset system when leaving configuration mode for GBCK003.  Fixes most issues with games.
 * Moved GBCK003 to its own source file, and added notes for both multi-game cartridge types.

-bus/gameboy: Improved GBCHK003 notes. [Vas Crabb]

-Changed fs::manager_t::enumerate_f() to simplify logic within file system drivers (#10106) [npwoods]
 * Changed fs::manager_t::enumerate_f() to simplify logic within file system drivers
   - enumerate_f() used to contain quite a bit of boilerplate logic to determine whether a particular floppy type should be added.
      This change attempts to move this logic outside the file system drivers to simplify the drivers.
   - The riskiest part of this change is unformatted_image::enumerate_f().  I attempted to replicate the logic that was previously
      determining with unformatted image types to use, but the logic is tricky and it isn't clear to me that replicating the logic
      is the correct action - I may be cargo culting.
 * Fix to floppy_image_device::fs_enum::add_raw()
 * Updating FS_FAT to reflect this PR
 * On the advise of Sarayan, I moved the filtering to the fs::manager_t::fs_enum base class.  This is actually a less intrusive
    change than what I originally had because it keeps the unformatted raw image handling closer to what we had previously.
   - Some misgivings about these changes: 1. We now have fs::manager_t::fs_enum::add() being a thin call that invokes a protected
      method called fs::manager_t::fs_enum::add_format().  Better ideas for names are welcome. 2. It feels odd that we've removed
      the need to do filtering from the various FS modules, but the unformatted module has to ask the fs_enum() for its internal
      variables for filtering to perform the same logic.  This seems to be the least worst option
   - Feedback is welcome

-mtu130: Fix 2bpp, fix ipl rom size, implement external rom support. [Olivier Galibert]

-diagnostics: ignore all but type 0x20 symbols [Patrick Mackinlay]

-hd44102: add intermediate render buffer [hap]

-fmtowns_flop_misc.xml: Use lowercase for descriptive text in descriptions. (#10348) [ArcadeShadow]

-c64_cart.xml: Cleaned up metadata. (#10347) [ArcadeShadow]
 * Use lowercase and avoid abbreviations in descriptive text.

-nes.xml: Corrected indorap ROM label. (#10342) [0kmg]

-nintendo/nes_m8.cpp: Made parent set 1 and oldest clone set 3. [0kmg]

-colexo.xml: Cleaned up metadata. (#10346) [ArcadeShadow]
 * Replaced Canada country abbreviation by the full name.
 * Use lowercase for descriptive text in descriptions ("Alt", "Prototype", "Earlier", Demo, "Bad").

-sega/megadriv_rad.cpp: add debug button option for dgunl3227 (#10350) [Devin Acker]
 * sega/megadriv_rad.cpp: add debug button option for dgunl3227
 * make button C explicitly unused when disabled

New working software list additions
-----------------------------------
arb: Grand Master Series 3, Sargon 3.5 [Berger]

-ave_arb: workaround for emumem bug [hap]

-Debugger updates: [Vas Crabb]
 * Made closing the Qt debugger console window hide all debugger windows and run the emulated machine (debugger windows will be
    shown on next user break or breakpoint hit).  This matches the behaviour of the Win32 and Cocoa debuggers.
 * Made Qt debugger clean up its windows on exit rather than on subsequent starts.  This fixes GitHub #9789.
 * Made Qt debugger less reliant on global variables, and made code to save and load configuration a bit less convoluted.  It still
    needs more refactoring on this front, but it's in slightly better shape now.
 * Made Qt debugger a bit less crashy on invalid configuration.  Still plenty of ways to crash it, but every little bit counts.
 * Made Qt debugger do less comparisons on menu item names and object names - it might be possible to localise one day.
 * Moved all the C++ debugger implementations into namespaces.  They're using awfully generic class names, so it's about time.

-Renamed n2a03 to rp2a03 throughout source tree. (#10343) [0kmg]

-Updated mess.flt [Robbbert]

-Revert "atari/atarigt.cpp:: Add Japanese release of Primal Rage version 2.3. (#10301)" (#10354) [Vas Crabb]
 * This reverts commit 8f30e3071f59a2893208d4f53b40d4ffd0f93462.

-fixed building with clang 15.0.0 on windows [smf-]

-hiscore.dat: resort and set changes [cracyc]

-gamepock: remove input tag lookups, add notes [hap]

-gamepock, gmaster: do the lcd colors with internal artwork [hap]

-upd7810: some variables were missing from savestates [hap]

-gamepock: use hd44102_device [hap]

-mtu130: Implement the banking using the actual sequencer prom [Olivier Galibert]

-Update docs on romcmp [AJR]

-osd/modules/debugger/debugqt.cpp: Don't try closing windows if debugger console wasn't created. [Vas Crabb]

-e132xs: Cleanups [AJR]
 * Use count_leading_zeros_32 instead of loop for TESTLZ
 * Simplify overflow mask calculation for SHL(I)

New working clones
------------------
Soul Calibur (Asia, SOC12/VER.A2) [nnap]

New clones marked as NOT_WORKING
--------------------------------
Maverick, The Movie (2.00) [Matt’s Basement Arcade, PinMAME]

-apple2cp: Use new IWM and floppy system.  Writing to 3.5" disks works now. [R. Belmont]

-famicom_cass.xml: Added six Micom BASIC Magazine games. (#10359) [0kmg]

New working software list additions (famicom_cass.xml)
------------------------------------------------------
Abunai Penpen! [ozidual, Gaming Alexandria]
Fruit Panic [ozidual, Gaming Alexandria]
Itazura Karasu [ozidual, Gaming Alexandria]
Kani-san no Hatahokobi [ozidual, Gaming Alexandria]
Star Dust [ozidual, Gaming Alexandria]
War Game [ozidual, Gaming Alexandria]

-docs: Updated build prerequisite package names for newer Ubuntu versions. (#10355) [goldnchild]

-ibm5170_cdrom.xml: Added three woring items. (#10349) [ArcadeShadow]

New working software list additions (ibm5170_cdrom.xml)
-------------------------------------------------------
Blackhawk (Europe) [Jackal, redump.org]
Network Q RAC Rally (USA) [MrX_Cuci, redump.org]
Supaplex (Europe) [Jackal, redump.org]

-Adding missing emu.h include [Olivier Galibert]

-bus/nubus/nubus_image.cpp, cpu/i386/i486ops.hxx: Use swapendian_int32 [AJR]

-dp83932c.cpp: Use swapendian_int16 [AJR]

-debuggdbstub.cpp: Use swapendian_int* [AJR]

New clones marked as NOT_WORKING
--------------------------------
Strikers 1945 III (World) / Strikers 1999 (Japan) (bootleg) [Bigblue709]

-snes.cpp updates: [Ivan Vangelista]
 * identified sblastb2a as actually being Teenage Mutant Ninja Turtles - Mutant Warriors [dox]
 * decrypted it [iq_132]
 * still doesn't work, possibly because of additional protection

-bandai/sv8000.cpp: Halved CPU clock. Fixes games running too fast. (#10358) [0kmg]

-apple2cp: fix VBL register access, solves hang in Prince of Persia [R. Belmont]

-sv8000.xml: Added Japanese titles and release years, and changed ROM sizes to hexadecimal. (#10357) [0kmg]

-lisa.cpp: preliminary switch to modern IWM/floppy devices. [R. Belmont]

-sonydriv.cpp: retired. [R. Belmont]

-Fix some incorrect rom locations and labels in Arkanoid and Cosmic Alien, add some notes, and mark an existing dump as good based
 on a redump [Brian Troha, Andy Welburn, Lord Nightmare]

-m6502: Add the missing uses_custom_memory_interface.  Avoid multiple instructions on one line for when reads at restartable.
 [Olivier Galibert]

-New Software List Entries (2x e-kara) (#10361) [David Haywood]

new software list entries
-------------------------
ekara_japan_s.xml: [David Haywood]
sc0014            Saiten Cartridge Challenge Idol vol.4 (Japan) (SC0014-SAI) [Team Europe]
sc0020            Saiten Cartridge Challenge Idol vol.5 (Japan) (SC0020-SAI) [Team Europe]

-h8, sh2: Add exception hook calls [AJR]

-debugview.mm: Raise requirement for Dark Mode to 10.15. [R. Belmont, kmg]

-es5503: More correct behavior in some swap-mode corner cases. [R. Belmont]

-apple2gs: Mega II banks now fully follow RAMRD/RAMWRT/ALTZP like banks $00/$01. [R. Belmont]

-midway/midwunit.cpp, psikyo/psikyo.cpp: small notes updates / corrections. [Ivan Vangelista]

-namco/namcops2.cpp: redumped HDD for cobrata [Guru]

-er1400: Correct clock phase and better handle data reads [Dirk Best]
 * Fixes various issues in drivers.

-famicom_cass.xml: Added one more Micom BASIC magazine game. (#10363) [0kmg]

New working software list additions
-----------------------------------
famicom_cass.xml: Star Ship Go!! [ozidual, Gaming Alexandria]

-a2600.xml: Added 19 homebrew cartridges. (#10364) [0kmg]

New working software list additions (a2600.xml)
-----------------------------------------------
Climber 5 (NTSC) [AtariAge]
Climber 5 (PAL) [AtariAge]
Gunfight (NTSC) [AtariAge]
Gunfight (PAL) [AtariAge]
Jammed [AtariAge]
Marble Craze (NTSC) [AtariAge]
Marble Craze (PAL) [AtariAge]
Oystron [AtariAge]
Qb (NTSC) [AtariAge]
Qb (PAL) [AtariAge]
Seawolf (NTSC) [AtariAge]
Seawolf (PAL) [AtariAge]
Space Instigators [AtariAge]
Star Fire (NTSC) [AtariAge]
Star Fire (PAL) [AtariAge]
Synthcart [AtariAge]
Testcart [AtariAge]
Thrust+ - D.C. Edition [AtariAge]
Thrust+ - Platinum Edition [AtariAge]

-arcadia.xml: Added Japanese titles to Bandai games. (#10360) [0kmg]

-mz2500.xml: Corrected gomokuna publisher. [0kmg]

-ibm5150.xml: 6 new working software list additions (#10365) [ArcadeShadow]

New working software list additions
-----------------------------------
Chess Simulator [The Good Old Days]
Chicago 90 [The Good Old Days]
California Pro Golf [The Good Old Days]
Command H.Q. (3.5") [The Good Old Days]
Command H.Q. (5.25") [The Good Old Days]
Expert Will (v1.4) [ibmpc5150, archive.org]

-Metadata correction: Change floppy interface to 3_5 on "Wizardry" games [ArcadeShadow]

-srcclean pass in preparation for release branch [Vas Crabb]

-diagnostics: fix clang Windows build (#10370) [invertego]
 * Restore necessary const qualifier removed by 0055a33e81b60284c6390e9c73db9fcb19b8ce8b

-docs: Corrected parent menu for input devices menu. [Vas Crabb]
